<?php
namespace FiloBlu\Rma\Block\Adminhtml\Rma\Edit\Tab;

use FiloBlu\Rma\Api\EasyReturnRepositoryInterface;
use Magento\Directory\Model\RegionFactory;


class General extends \Magento\Rma\Block\Adminhtml\Rma\Edit\Tab\General
{
    /**
     * @var EasyReturnRepositoryInterface
     */
    private $easyReturnRepository;
    /**
     * @var RegionFactory
     */
    private $regionFactory;

    /**
     * General constructor.
     * @param \Magento\Backend\Block\Template\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param \Magento\Framework\Data\FormFactory $formFactory
     * @param EasyReturnRepositoryInterface $easyReturnRepository
     * @param RegionFactory $regionFactory
     * @param array $data
     */
    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\Data\FormFactory $formFactory,
        EasyReturnRepositoryInterface $easyReturnRepository,
        RegionFactory $regionFactory,
        array $data = [])
    {
        parent::__construct($context, $registry, $formFactory, $data);
        $this->easyReturnRepository = $easyReturnRepository;
        $this->regionFactory = $regionFactory;
    }


    /**
     * @return \Magento\Sales\Api\Data\OrderAddressInterface
     */
    public function getPickupAddress(){
        try{
            /** @var $rma \Magento\Rma\Model\Rma */
            $rmaId =   $this->getRequest()->getParam('id');
            $easyReturn = $this->easyReturnRepository->getByRmaId($rmaId);
            if($easyReturn){
                if($regionId = $easyReturn->getRegionId()){
                    $regionName = $this->regionFactory->create()->load($easyReturn->getRegionId());
                    $easyReturn->setRegion($regionName->getName());
                }
                return $easyReturn->getPickUpAddress();
            }
        }catch (\Exception $e){
            $this->_logger->critical($e->getMessage());
        }catch (\Throwable $t){
            $this->_logger->critical($t->getMessage());
        }
    }
}